From d3ed2b4f6e92b742d763d6fd4684dd4a3ae50f5f Mon Sep 17 00:00:00 2001
From: Stephen Wang <wstephen@codeaurora.org>
Date: Fri, 24 Apr 2015 23:44:32 -0700
Subject: [PATCH 1/2] [nss-gmac] Read descriptor status only once

Change-Id: Ic2fed0d39051e1d5da9b53d087f9842cc2fdc306
Signed-off-by: Stephen Wang <wstephen@codeaurora.org>
---
 ipq806x/nss_gmac_tx_rx_offload.c |   11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

diff --git a/ipq806x/nss_gmac_tx_rx_offload.c b/ipq806x/nss_gmac_tx_rx_offload.c
index 4716ba8..af94b6a 100644
--- a/ipq806x/nss_gmac_tx_rx_offload.c
+++ b/ipq806x/nss_gmac_tx_rx_offload.c
@@ -229,12 +229,13 @@ static inline int nss_gmac_rx(struct nss_gmac_dev *gmacdev, int budget)
 
 	do {
 		desc = gmacdev->rx_busy_desc;
-		if (nss_gmac_is_desc_owned_by_dma(desc)) {
+		rmb();
+		status = desc->status;
+		if (status & desc_own_by_dma) {
 			/* desc still hold by gmac dma, so we are done */
 			break;
 		}
 
-		status = desc->status;
 		rx_skb = (struct sk_buff *)desc->reserved1;
 		dma_unmap_single(&gmacdev->netdev->dev, desc->buffer1,
 				NSS_GMAC_MINI_JUMBO_FRAME_MTU, DMA_FROM_DEVICE);
@@ -298,7 +299,10 @@ static inline void nss_gmac_process_tx_complete(struct nss_gmac_dev *gmacdev)
 
 	do {
 		desc = gmacdev->tx_busy_desc;
-		if (nss_gmac_is_desc_owned_by_dma(desc)) {
+
+		rmb();
+		status = desc->status;
+		if (desc->status & desc_own_by_dma) {
 			/* desc still hold by gmac dma, so we are done */
 			break;
 		}
@@ -306,7 +310,6 @@ static inline void nss_gmac_process_tx_complete(struct nss_gmac_dev *gmacdev)
 		dma_unmap_single(&gmacdev->netdev->dev, desc->buffer1, len,
 								DMA_TO_DEVICE);
 
-		status = desc->status;
 		if (status & desc_tx_last) {
 			/* TX is done for this whole skb, we can free it */
 			skb = (struct sk_buff *)desc->reserved1;
-- 
1.7.9.5

